# USE jtag for openocd in ESP32

## board 

ESP-C3-32S-Kit https://docs.ai-thinker.com/_media/esp32/docs/esp-c3-32s-kit-v1.0_规格书.pdf

## install JLink deb software and driver

## build esp32-c3 binary

```bash
# At esp-idf
source export.sh
cd examples/get-started/blink
idf.py set-target esp32-c3
idf.py menuconfig # config the io and LED mode
idf.py build
idf.py -p (PORT) flash # to flash to module to verify the effect of binary by USART port
```

## 配置ESP32

由于 ESP32-C3 默认选用 内置的 USB_SERIAL_JTAG 外设。此时需要烧录 efuse 来选择外接 JTAG 适配器，有以下两种方式：  

* 烧毁 DIS_USB_JTAG eFuse： 将永久禁用 USB_SERIAL_JTAG 和 CPU 的 JTAG 端口之间的连接。 然后可以将 JTAG 接口连接到 GPIO4 - GPIO7。 请注意，USB_SERIAL_JTAG 的 USB CDC 功能仍然可用，即仍然可以通过 USB CDC 进行烧录和 log 查看。
* 烧毁 JTAG_SEL_ENABLE eFuse： 将启用由 Strapping 引脚 GPIO10 选择的 JTAG 接口。 如果 ESP32-C3 复位时 Strapping 引脚为低电平，则 JTAG 接口将使用 GPIO4 - GPIO7。 如果 Strapping 引脚为高电平，则 USB_SERIAL_JTAG 将用作 JTAG 接口。  

`espefuse.py burn_efuse JTAG_SEL_ENABLE -p /dev/ttyUSB0`
然后你会得到一个需要输入BURN 的确认信息，如下：

```bash
Connecting....
Detecting chip type... ESP32-C3
espefuse.py v3.3-dev
The efuses to burn:
  from BLOCK0
     - JTAG_SEL_ENABLE

Burning efuses:

    - 'JTAG_SEL_ENABLE' (Disables USB JTAG. JTAG access via pads is controlled separately) 0b0 -> 0b1

Check all blocks for burn...
idx, BLOCK_NAME,          Conclusion
[00] BLOCK0               is not empty
        (written ): 0x000000000000008000000000000000000000800000000000
        (to write): 0x000000000000000000000000000000000000020000000000
        (coding scheme = NONE)
. 
This is an irreversible operation!
Type 'BURN' (all capitals) to continue.
```

## usage

* 链接JLink的 jtag 四个IO，`TMS` `TDI` `TDO` `TCK`
* 默认固件开发板的JTAG IO不能用于其他功能，必须是闲置状态
* Must use esp's `openocd` by source export.sh in esp-idy, after esp-idf installed.

## cmd

* `./openocd.sh`  start openocd
* `./gdb.sh` start gdb
